(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('event-context')) :
  typeof define === 'function' && define.amd ? define(['exports', 'event-context'], factory) :
  (factory((global.EventContextPluginJquery = global.EventContextPluginJquery || {}),global.EventContext));
}(this, (function (exports,eventContext) { 'use strict';

var patch = function ($) {
  var $add = $.event.add;
  var $remove = $.event.remove;

  $.event.add = function (elem, types, handler, data, selector) {
    // console.log(elem, types, handler, data, selector);
    var ctx = eventContext.getCurrentContext();
    if (!ctx) {
      return $add.call(this, elem, types, handler, data, selector);
    }

    var computation = function () {
      var args = [], len = arguments.length;
      while ( len-- ) args[ len ] = arguments[ len ];

      eventContext.setCurrentContext(ctx);
      handler.__computation = computation;
      handler.call.apply(handler, [ this ].concat( args ));
      eventContext.revertContext();
    }

    ctx.addDisposable(
      function () {
        $remove(elem, types, computation, selector);
      }
    );

    return $add.call(this, elem, types, computation, data, selector);
  }

  $.event.remove = function (elem, types, handler, selector, mappedTypes) {
    if (typeof handler === 'function' && typeof handler.__computation === 'function') {
      return $remove.call(this, elem, types, handler.__computation, selector, mappedTypes);
    }
    return $remove.call(this, elem, types, handler, selector, mappedTypes);
  }
}

exports.patch = patch;

Object.defineProperty(exports, '__esModule', { value: true });

})));